<?php
/**
 * AgileBill - Open Billing Software
 *
 * This body of work is free software; you can redistribute it and/or
 * modify it under the terms of the Open AgileBill License
 * License as published at http://www.agileco.com/agilebill/license1-4.txt
 *
 * Originally authored by Tony Landis, AgileBill LLC
 *
 * Recent modifications by Deon George
 *
 * @author Deon George <deonATleenooksDOTnet>
 * @copyright 2009 Deon George
 * @link http://osb.leenooks.net
 *
 * @link http://www.agileco.com/
 * @copyright 2004-2008 Agileco, LLC.
 * @license http://www.agileco.com/agilebill/license1-4.txt
 * @author Tony Landis <tony@agileco.com>
 * @package AgileBill
 * @subpackage Modules:FAQ
 */

/**
 * The main AgileBill FAQ Category Class
 *
 * @package AgileBill
 * @subpackage Modules:FAQ
 */
class faq_category extends OSB_module {
	##############################
	##	GET AUTH CATEGORIES     ##
	##############################
	function category_list($VAR)
	{	

		/* check if current session is authorized for any ticket departments..
			and return true/false...
		*/
		global $smarty;
		$db     = &DB();
		$sql    = 'SELECT DISTINCT fc.id,fc.name,fc.group_avail,count(f.id) children, fc.site_id, fc.status 
					FROM 
					' . AGILE_DB_PREFIX . 'faq_category fc
					INNER JOIN
					' . AGILE_DB_PREFIX . 'faq f ON f.faq_category_id = fc.id 
					GROUP BY (fc.id)
					HAVING
					site_id     = ' . $db->qstr(DEFAULT_SITE) . ' AND
					status      = ' . $db->qstr('1') .'
					ORDER BY fc.sort_order,fc.name';

		$result = $db->Execute($sql);

		if($result->RecordCount() == 0)
		{
			$smarty->assign('faq_category_list_display', false);
			return false;
		}

		global $C_auth;
		$ii = 0;

		while(!$result->EOF)
		{
			@$arr = unserialize($result->fields['group_avail']);

			for($i=0; $i<count($arr); $i++)
			{
				if($C_auth->auth_group_by_id($arr[$i]))
				{
					### Add to the array
					$ii++;
					$arr_smarty[] = Array(  'name'          => $result->fields['name'],
											'id'            => $result->fields['id'],
											'children'	=> $result->fields['children']);

					$i=count($arr);
				}
			}
			$result->MoveNext();
		}

		if($ii == "0")
		{
			 $smarty->assign('faq_category_list_display', false);
			 return false;
		}
		else
		{
			$smarty->assign('faq_category_list_display', 	true);
			$smarty->assign('faq_category_list_results', 	$arr_smarty);
			return true;
		}
	}
}
?>
