<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class provides User Payment functions
 *
 * @package    OSB
 * @subpackage Payment
 * @category   Controllers/User
 * @author     Deon George
 * @copyright  (c) 2010 Deon George
 * @license    http://dev.leenooks.net/license.html
 */
class Controller_User_Payment extends Controller_TemplateDefault {
	public $secure_actions = array(
		'list'=>TRUE,
		'view'=>TRUE,
	);

	/**
	 * Show a payments received
	 */
	public function action_list() {
		$id = Auth::instance()->get_user()->id;
		$ao = ORM::factory('account',$id);

		if (! $ao->loaded())
			throw new Kohana_Exception('Account doesnt exist :account ?',array(':account'=>$id));

		Block::add(array(
			'title'=>sprintf('%s: %s - %s',_('Payments For'),$ao->accnum(),$ao->name(TRUE)),
			'body'=>View::factory('payment/user/list')
				->set('payments',$ao->payment->find_all()),
			));
	}
}
?>
