<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class supports ADSL products
 *
 * @package    OSB
 * @subpackage Product/ADSL
 * @category   Models
 * @author     Deon George
 * @copyright  (c) 2010 Open Source Billing
 * @license    http://dev.osbill.net/license.html
 */
class Model_Product_ADSL extends Model_Product {
	protected $_table_name = 'adsl_plan';
	protected $_primary_key = 'id';

	protected $_sorting = array(
	);

	protected $_display_filters = array(
		'extra_down_peak'=>array(
			array('Tax::add',array(':value')),
			array('Currency::display',array(':value')),
		),
		'extra_down_offpeak'=>array(
			array('Tax::add',array(':value')),
			array('Currency::display',array(':value')),
		),
	);

	protected function _feature_summary() {
		return View::factory('product/adsl/feature_summary')
			->set('po',$this);
	}

	protected function _summary() {
		return sprintf('%s: %s %s','ADSL Services',$this->speed,$this->allowance(TRUE));
	}

	/**
	 * Show the ADSL allowance as a peak/offpeak metric
	 */
	public function allowance($string=TRUE) {
		$output = ADSL::allowance(array(
			'base_down_peak'=>$this->base_down_peak,
			'base_down_offpeak'=>$this->base_down_offpeak,
			'base_up_peak'=>$this->base_up_peak,
			'base_up_offpeak'=>$this->base_up_offpeak,
			'extra_down_peak'=>$this->extra_down_peak,
			'extra_down_offpeak'=>$this->extra_down_offpeak,
			'extra_up_peak'=>$this->extra_up_peak,
			'extra_up_offpeak'=>$this->extra_up_offpeak,
			));

		return $string ? implode('/',$output) : $output;
	}
}
?>
