<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class provides User Service functions
 *
 * @package    OSB
 * @subpackage Service
 * @category   Controllers/User
 * @author     Deon George
 * @copyright  (c) 2010 Deon George
 * @license    http://dev.leenooks.net/license.html
 */
class Controller_User_Service extends Controller_TemplateDefault {
	public $secure_actions = array(
		'list'=>TRUE,
		'view'=>TRUE,
	);
	// Our acccount object
	private $ao;

	public function before() {
		parent::before();

		$this->ao = ORM::factory('account',Auth::instance()->get_user()->id);
		if (! $this->ao->loaded())
			throw new Kohana_Exception('Account doesnt exist :account ?',array(':account'=>Auth::instance()->get_user()->id));
	}

	/**
	 * Show a product
	 */
	public function action_list() {
		Block::add(array(
			'title'=>sprintf('%s: %s - %s',_('Services For'),$this->ao->accnum(),$this->ao->name(TRUE)),
			'body'=>View::factory('service/user/list')
				->set('services',$this->ao->service->find_all()),
			));
	}

	public function action_view($id) {
		$so = ORM::factory('service',$id);

		if (! $so->loaded() OR ! Auth::instance()->authorised($so->account_id)) {
			$this->template->content = 'Unauthorised or doesnt exist?';
			return FALSE;
		}

		Block::add(array(
			'title'=>sprintf('%s: %s',$so->id(),$so->product->name()),
			'body'=>View::factory('service/user/view')
				->set('so',$so),
			));
	}
}
?>
